<?php
$include_path = ini_get('include_path');
ini_set('include_path', $include_path . ':' . dirname(dirname(dirname(__FILE__))));

require_once 'PHPUnit/Framework.php';
require_once 'Xpw/System/Base.php';

class BasePropertyExample extends Xpw_System_Base 
{
	private $_a;
	
	private $_b;
	
	protected function aPropertySet($value)
	{
	 	$this->_a = $value;
	}
	
	protected function aPropertyGet()
	{
		return $this->_a;
	}
	
	protected function aPropertyIsset()
	{
		return isset($this->_a);
	}
	
	protected function aPropertyUnset()
	{
		unset($this->_a);
	}
	
	public function isProtectedPropertySet()
	{
		return isset($this->a);
	}
	
	public function setProtectedProperty($value)
	{
		$this->a = $value;
	}
	
	public function getProtectedProperty()
	{
		return $this->a;
	}
	
	public function unsetProtectedProperty()
	{
		unset($this->a);
	}
	
	protected function bPropertySet($value)
	{
	 	$this->_b = $value;
	}
	
	protected function bPropertyGet()
	{
		return $this->_b;
	}
	
	protected function bPropertyIsset()
	{
		return isset($this->_b);
	}
	
	protected function bPropertyUnset()
	{
		unset($this->_b);
	}
}

class BaseTest extends PHPUnit_Framework_TestCase
{
	/**
	 * BaseProperty
	 *
	 * @var BaseProperty
	 */
	protected $baseProperty;
	
	protected function SetUp()
	{
		$this->baseProperty = new BasePropertyExample();
	}
	
	public function testProtectedProperty()
	{
		$this->assertFalse($this->baseProperty->isProtectedPropertySet());
		$this->baseProperty->setProtectedProperty('hello');
		$this->assertEquals('hello', $this->baseProperty->getProtectedProperty());
		$this->assertTrue($this->baseProperty->isProtectedPropertySet());
		$this->baseProperty->unsetProtectedProperty();
		$this->assertFalse($this->baseProperty->isProtectedPropertySet());
	}
	
	public function testPublicProperty()
	{
		$this->assertFalse(isset($this->baseProperty->b));
		$this->baseProperty->b = 'hello';
		$this->assertEquals('hello', $this->baseProperty->b);
		$this->assertTrue(isset($this->baseProperty->b));
		unset($this->baseProperty->b);
		$this->assertFalse(isset($this->baseProperty->b));
	}
}
?>