<?php
/**
 * XPW Framework
 *
 * LICENSE
 *
 * This source file is subject to the LGPLv3 license that is bundled
 * with this package in the file LICENSE.
 * It is also available through the world-wide-web at this URL:
 * http://xpw.ukrsoftsolutions.com/license
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@xpw.ukrsoftsolutions.com so we can send you a copy immediately.
 *
 * @category   XPW
 * @package    Xpw_System_Attribute
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @version    1.0beta1
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */


/**
 * @see Xpw_System_Attribute_Exception
 *
 */
require_once 'Xpw/System/Attribute/Exception.php';


/**
 * @see Xpw_System_Base
 *
 */
require_once 'Xpw/System/Base.php';

/**
 * @category   XPW
 * @package    Xpw_System_Attribute
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */
abstract class Attribute extends Xpw_System_Base 
{
	const CLASS_CONTEXT = 'CLASS';
	
	const FUNCTION_CONTEXT = 'FUNCTION';
	
	const METHOD_CONTEXT = 'METHOD';
	
	const MEMBER_CONTEXT = 'MEMBER';
	
	const PROPERTY_CONTEXT = 'PROPERTY';
	
	private $_context;
	
	protected $_supportedContexts = array(
			self::CLASS_CONTEXT,
			self::FUNCTION_CONTEXT,
			self::MEMBER_CONTEXT,
			self::METHOD_CONTEXT,
			self::PROPERTY_CONTEXT
		);
	
	public function __construct($context)
	{
		$this->setContext($context);
	}
	
	private function setContext($context)
	{
		if (in_array($context->context, $this->_supportedContexts))
			$this->_context = $context;
		else
			throw new Xpw_System_Attribute_Exception('Class \'' . __CLASS__ . '\' cannot be used in this context.');
	}
}
?>