<?php
/**
 * XPW Framework
 *
 * LICENSE
 *
 * This source file is subject to the LGPLv3 license that is bundled
 * with this package in the file LICENSE.
 * It is also available through the world-wide-web at this URL:
 * http://xpw.ukrsoftsolutions.com/license
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@xpw.ukrsoftsolutions.com so we can send you a copy immediately.
 *
 * @category   XPW
 * @package    Xpw_System_String
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @version    1.0beta1
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */

require_once 'Xpw/System/Value.php';

/**
 * @category   XPW
 * @package    Xpw_System_String
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */
final class Xpw_System_String extends Xpw_System_Value 
{
	public function addCSlashes()
	{
		return new Xpw_System_String(addcslashes($this->_value));
	}
	/**
	 * Indents string with another.
	 *
	 * @param string $indentString
	 * @return Xpw_System_String
	 */
	public function indent($indentString)
	{
		return new Xpw_System_String($indentString . $this->_value);
	}
	
	/**
	 * Indents multiline string with another one.
	 *
	 * @param string $indentString
	 * @param string $lineDelimiter
	 * @return Xpw_System_String
	 */
	public function indentMultiline($indentString, $lineDelimiter = "\n")
	{
		$lines = explode($lineDelimiter, $this->_value);
		for ($i = 0; $i < count($lines); $i++)
			if (strlen($lines[$i]) > 0)
				$lines[$i] = $indentString . $lines[$i];
			
		return new Xpw_System_String(implode($lineDelimiter, $lines));
	}	
}
?>