<?php
/**
 * XPW Framework
 *
 * LICENSE
 *
 * This source file is subject to the LGPLv3 license that is bundled
 * with this package in the file LICENSE.
 * It is also available through the world-wide-web at this URL:
 * http://xpw.ukrsoftsolutions.com/license
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@xpw.ukrsoftsolutions.com so we can send you a copy immediately.
 *
 * @category   XPW
 * @package    Xpw_System_Value
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @version    1.0beta1
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */

require_once 'Xpw/System/Base.php';

/**
 * @category   XPW
 * @package    Xpw_System_Value
 * @copyright  Copyright (c) 2008 UkrSoftSolutions (http://www.ukrsoftsolutions.com)
 * @license    http://xpw.ukrsoftsolutions.com/license     LGPLv3 License
 */
abstract class Xpw_System_Value extends Xpw_System_Base 
{
	/**
	 * String value.
	 *
	 * @var string
	 */
	protected $_value;

	/**
	 * Creates new instance of the class.
	 *
	 * @param string $value
	 */
	public function __construct($value = null)
	{
		$this->_value = $value;
	}
	
	/**
	 * Gets value of the value property.
	 *
	 * @return string
	 */
	protected function valuePropertyGet()
	{
		return $this->_value;
	}
	
	/**
	 * Sets value of the value property.
	 *
	 * @param string $value
	 */
	protected function valuePropertySet($value)
	{
		$this->_value = $value;
	}
	
	/**
	 * Whether value property isset.
	 *
	 * @return bool
	 */
	protected function valuePropertyIsset()
	{
		return isset($this->_value);
	}
	
	/**
	 * Unsets the value property
	 *
	 */
	protected function valuePropertyUnset()
	{
		unset($this->_value);
	}
	
	/**
	 * Returns string representation of the class instance
	 *
	 * @return string
	 */
	public function __toString()
	{
		return $this->_value;
	}
}
?>